<nz-spin nzTip="Loading..." [nzSpinning]="isLoading">
  <nz-card [nzTitle]="financesTitle" style="text-align: left" nzSize="small"
    [nzExtra]="showHistoryButton ? financeExtra : null">
    <!-- CARD -->
    <ng-template #financesTitle>
      {{ "Economy.Finances" | translate }}
    </ng-template>
    <ng-template #financeExtra>
      <span style="float: right; margin-right: 20px" *ngIf="showHistoryButton" (click)="loadHistory()" nz-tooltip
        nzTooltipTitle='{{ "Entity.welfareHistory" | translate }}'><i class="fas fa-history"></i></span>
    </ng-template>

    <!-- LIST -->
    <nz-list nzBordered [nzFooter]="canEdit ? addNewCurrency : null" nzSize="small">
      @for (i of currencies; track i) {
      <nz-list-item>
        <div nz-flex nzJustify="flex-start" nzAlign="center">
          <img style="width: 25px; height: 20px; margin-right: 3px" src="{{ i.currency.flagLocation }}" />
          <div style="padding-top: 1px">{{ i.amount }} {{ i.currency.symbol | translate }}</div>
        </div>

        <div>
          <nz-button-group>
            <button nz-button nzShape="round" nzSize="small" nz-tooltip
              nzTooltipTitle='{{ "Entity.currencyHistory" | translate }}'>
              <i class="fas fa-history"></i>
            </button>

            <button *ngIf="canEdit" nz-button nzShape="round" nzSize="small" nzDanger nz-tooltip
              nzTooltipTitle='{{ "Entity.modifyCurrency" | translate }}' (click)="showModifyForm(i.currency.id)">
              <i class="fas fa-cog"></i>
            </button>
          </nz-button-group>
        </div>
      </nz-list-item>
      }
    </nz-list>

    <ng-template #addNewCurrency>
      <div style="text-align: center;">
        <button nz-button nzShape="round" nzSize="small" nzDanger (click)="showModifyForm()">
          {{ "Entity.addNewCurrency" | translate }}
        </button>
      </div>
    </ng-template>

  </nz-card>
</nz-spin>

<nz-modal nzVisible *ngIf="modifyCurrencyForm !== undefined" nzTitle='{{ "Entity.editCurrency" | translate }}'
  (nzOnCancel)="modifyCurrencyForm = undefined" (nzOnOk)="submitModifyForm()" [nzOkLoading]="isLoading">
  <ng-container *nzModalContent>

    <nz-spin [nzSpinning]="isLoading">
      <form nz-form [formGroup]="modifyCurrencyForm">

        <nz-form-item *ngIf="allCurrencies">
          <nz-form-label [nzSm]="6" [nzXs]="24" nzRequired>{{ "Entity.Currency" | translate }}</nz-form-label>
          <nz-form-control [nzSm]="14" [nzXs]="24">
            <nz-select formControlName="currencyId">
              <nz-option *ngFor="let item of allCurrencies" [nzValue]="item.id" [nzLabel]="item.symbol"></nz-option>
            </nz-select>
          </nz-form-control>
        </nz-form-item>

        <nz-form-item>
          <nz-form-label [nzSm]="6" [nzXs]="24" nzRequired>{{ "Entity.action" | translate }}</nz-form-label>
          <nz-form-control [nzSm]="14" [nzXs]="24">
            <nz-select formControlName="action" style="width: 100%">
              <nz-option nzValue="+" nzLabel="Give"></nz-option>
              <nz-option nzValue="-" nzLabel="Take"></nz-option>
            </nz-select>
          </nz-form-control>
        </nz-form-item>

        <nz-form-item>
          <nz-form-label [nzSm]="6" [nzXs]="24" nzRequired>{{ "Entity.amount" | translate }}</nz-form-label>
          <nz-form-control [nzSm]="14" [nzXs]="24">
            <input nz-input formControlName="amount" />
          </nz-form-control>
        </nz-form-item>

        <nz-form-item>
          <nz-form-label [nzSm]="6" [nzXs]="24" nzRequired>{{ "Common.Reason" | translate }}</nz-form-label>
          <nz-form-control [nzSm]="14" [nzXs]="24">
            <textarea rows="4" nz-input formControlName="reason"></textarea>
          </nz-form-control>
        </nz-form-item>
      </form>
    </nz-spin>

  </ng-container>
</nz-modal>

<!-- <span class="currency-history" *ngIf="editCurrencyData">
  <nz-modal [(nzVisible)]="editModalVisible" nzTitle="Edit finances" (nzOnCancel)="editModalVisible = false"
    (nzOnOk)="editCurrencySubmit()" [nzOkLoading]="isLoading">
    <ng-container *nzModalContent>
      <div>{{ "Economy.Currencies.EditingCurrency" | translate }}: {{ editCurrencyData.name | translate }}</div>
      <div>{{ "Economy.Currencies.CurrentValue" | translate }}: {{ editCurrencyData.amount }}</div>
      <div>
        <input nz-input placeholder="New value" [(ngModel)]="editCurrencyData.newValue" />
      </div>
    </ng-container>
  </nz-modal>

  <nz-modal nzMaskClosable="false" [(nzVisible)]="historyModalVisible" nzTitle="Welfare history"
    (nzOnCancel)="historyModalVisible = false" nzWidth="80%" [nzFooter]="null">
    <ng-container *nzModalContent>
      <nz-tabset>
        <nz-tab [nzTitle]="donationsTab" [nzDisabled]="historyDonations.isLoading">
          <ng-template #donationsTab>
            {{ "Donations.Dona" | translate }}
            <nz-spin style="float: right; margin-left: 10px" [nzSize]="'small'" nzSimple
              [nzSpinning]="historyDonations.isLoading"></nz-spin>
          </ng-template>
          <nz-table *ngIf="!historyDonations.isLoading" #donatonsTable [nzData]="historyDonations.list">
            <thead>
              <tr>
                <th>{{ "Common.From" | translate }}</th>
                <th>{{ "Economy.Currencies.ItemsCurrencies" | translate }}</th>
                <th>{{ "Common.Date" | translate }}</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let data of donatonsTable.data">
                <td>{{ data.from }}</td>
                <td>{{ data.fromItems }}</td>
                <td>
                  {{ data.date }}
                </td>
              </tr>
            </tbody>
          </nz-table>
        </nz-tab>

        <nz-tab [nzTitle]="tradesTab" [nzDisabled]="historyTrades.isLoading">
          <ng-template #tradesTab>
            {{ "Economy.Trade.Trades" | translate }}
            <nz-spin style="float: right; margin-left: 10px" [nzSize]="'small'" nzSimple
              [nzSpinning]="historyTrades.isLoading"></nz-spin>
          </ng-template>
          <nz-table *ngIf="!historyTrades.isLoading" #tradesTable [nzData]="historyTrades.list">
            <thead>
              <tr>
                <th>{{ "Common.From" | translate }}</th>
                <th>{{ "Common.To" | translate }}</th>
                <th>{{ "Economy.Currencies.ItemsCurrencies" | translate }}</th>
                <th>{{ "Economy.Currencies.ItemsCurrencies" | translate }}</th>
                <th>{{ "Common.Date" | translate }}</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let data of tradesTable.data">
                <td>{{ data.from }}</td>
                <td>{{ data.to }}</td>
                <td>{{ data.fromItems }}</td>
                <td>{{ data.toItems }}</td>
                <td>
                  {{ data.date }}
                </td>
              </tr>
            </tbody>
          </nz-table>
        </nz-tab>

        <nz-tab [nzTitle]="goldPurchasesTab" [nzDisabled]="goldPurchases.isLoading">
          <ng-template #goldPurchasesTab>
            {{ "Economy.Currencies.GoldPurchases" | translate }}
            <nz-spin style="float: right; margin-left: 10px" [nzSize]="'small'" nzSimple
              [nzSpinning]="goldPurchases.isLoading"></nz-spin>
          </ng-template>
          <nz-table *ngIf="!goldPurchases.isLoading" #goldPurchasesTable [nzData]="goldPurchases.list">
            <thead>
              <tr>
                <th>{{ "Economy.Market.Amount" | translate }}</th>
                <th>{{ "Common.Date" | translate }}</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let item of goldPurchasesTable.data">
                <td>{{ item.amount }}</td>
                <td>
                  {{ item.date }}
                </td>
              </tr>
            </tbody>
          </nz-table>
        </nz-tab>
      </nz-tabset>
    </ng-container>
  </nz-modal>
</span> -->
